--
-- Real Shovel for FS19
-- @author:    	kenny456 (kenny456@seznam.cz)
-- @history:	v1.0 - 2020-04-01 - first release
--
source(Utils.getFilename("realShovel.lua", g_currentModDirectory))

RealShovel_register = {}

function RealShovel_register:loadMap()
end
function RealShovel_register:register(name)
	if g_specializationManager:getSpecializationByName("RealShovel") == nil then
	  if RealShovel == nil then 
		print("ERROR: unable to add specialization 'RealShovel'")
	  else 
		for i, typeDef in pairs(g_vehicleTypeManager.vehicleTypes) do
			if typeDef ~= nil and i ~= "locomotive" and i ~= "trainTrailer" and i ~= "trainTimberTrailer" then 
				local isShovel = false
				local isLeveler = false
				local isFillUnit = false
				for name, spec in pairs(typeDef.specializationsByName) do
					if name == "shovel"  then
						isShovel = true
					elseif name == "leveler"  then
						isLeveler = true
					elseif name == "fillUnit"  then
						isFillUnit = true
					end 
				end 
				if isShovel and not isLeveler and isFillUnit then
					typeDef.specializationsByName["RealShovel"] = RealShovel
					table.insert(typeDef.specializationNames, "RealShovel")
					table.insert(typeDef.specializations, RealShovel)  
				end 
			end 
		end   
	  end 
	end
end
VehicleTypeManager.finalizeVehicleTypes = Utils.prependedFunction(VehicleTypeManager.finalizeVehicleTypes, RealShovel_register.register)
print("----RealShovel registered.")

addModEventListener(RealShovel_register);